#include <Wire.h>
#include "IS31FL3733.h"

// https://github.com/LT11222/IS31FL3733
// https://github.com/kempermo/IS31FL3731-Library

// I2C SDA --> GPIO 21
// I2C SCL --> GPIO 22
// LED_SDB --> GPIO 4

int CHA = 6; // Blue
int CHB = 7; // red
int CHC = 8;
int SDB = 10;
int INTB = 9;

int k = 255;

// 0~5 = D01~D06
// 8~9 = D07~D08
// 10~13 = D09~D12
// 13,29 = D12
// 32~37 = D13~D18
// 40~45 = D19~D24
// 64~69 = D25~D30
// 72~76 = D31~D35
int led[] = {0, 1, 2, 3, 4, 5, 8, 9, 10, 11, 12, 13, 32, 33, 34, 35, 36, 37, 40, 41, 42, 43, 44, 45, 64, 65, 66, 67, 68, 69, 72, 73, 74, 75, 76};
int defaultLED = 17;
int lightR = 0;
int lightL = 0;
int swT = 20; // 10 look is okay.
IS31FL3733 device;

void setup()
{
  Serial.begin(115200);
  Wire.begin();
  Serial.println("ESP32 Start.");
  pinMode(INTB, OUTPUT);
  digitalWrite(INTB, HIGH);
  pinMode(SDB, OUTPUT);
  digitalWrite(SDB, HIGH);
  Serial.println("INTB & SDB pull high.");

  device.init();
  Serial.println("ISSI 31FL3737 initial done.");
  device.setCurrent();
  Serial.println("LED Driver set current finish.");
  //  pinMode(0, OUTPUT);
  //  digitalWrite(0, HIGH);
  //
  //  pinMode(1, OUTPUT);
  //  digitalWrite(1, HIGH);
  Serial.println("System turn ON finished.");

  Serial.println("LED dimming test.");
  delay(100);

  //  digitalWrite(0, HIGH);
  //  delay(1000);
  //  digitalWrite(1, HIGH);
  //  delay(1000);
}

void loop()
{
  for (int i = 0; i < 24; i++) {
    device.led_state(i, 0x3F);
  }

  for (int j = 0; j <= 128; j = j + 8) { //j<=128;j=j+8 j<=256;j=j+16
    for (int i = 0; i < 190; i++) {
      device.led_pwm(i, k);
    }
    delay(1);//50
  }
}
